# coding: utf-8

"""
    Digitick REST API

    The Digitick REST API is a set of methods giving access to catalog, user and cart management.

    OpenAPI spec version: v1.0
    Contact: contact@digitick.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Booking(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id=None, expiration_delay=None, sales_channel_id=None, user_id=None, creation_date=None, booking_tickets=None, total_amount=None):
        """
        Booking - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'int',
            'expiration_delay': 'int',
            'sales_channel_id': 'int',
            'user_id': 'int',
            'creation_date': 'str',
            'booking_tickets': 'list[int]',
            'total_amount': 'list[TaxMoneyList]'
        }

        self.attribute_map = {
            'id': 'id',
            'expiration_delay': 'expirationDelay',
            'sales_channel_id': 'salesChannelId',
            'user_id': 'userId',
            'creation_date': 'creationDate',
            'booking_tickets': 'bookingTickets',
            'total_amount': 'totalAmount'
        }

        self._id = id
        self._expiration_delay = expiration_delay
        self._sales_channel_id = sales_channel_id
        self._user_id = user_id
        self._creation_date = creation_date
        self._booking_tickets = booking_tickets
        self._total_amount = total_amount

    @property
    def id(self):
        """
        Gets the id of this Booking.

        :return: The id of this Booking.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Booking.

        :param id: The id of this Booking.
        :type: int
        """

        self._id = id

    @property
    def expiration_delay(self):
        """
        Gets the expiration_delay of this Booking.

        :return: The expiration_delay of this Booking.
        :rtype: int
        """
        return self._expiration_delay

    @expiration_delay.setter
    def expiration_delay(self, expiration_delay):
        """
        Sets the expiration_delay of this Booking.

        :param expiration_delay: The expiration_delay of this Booking.
        :type: int
        """

        self._expiration_delay = expiration_delay

    @property
    def sales_channel_id(self):
        """
        Gets the sales_channel_id of this Booking.

        :return: The sales_channel_id of this Booking.
        :rtype: int
        """
        return self._sales_channel_id

    @sales_channel_id.setter
    def sales_channel_id(self, sales_channel_id):
        """
        Sets the sales_channel_id of this Booking.

        :param sales_channel_id: The sales_channel_id of this Booking.
        :type: int
        """

        self._sales_channel_id = sales_channel_id

    @property
    def user_id(self):
        """
        Gets the user_id of this Booking.

        :return: The user_id of this Booking.
        :rtype: int
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this Booking.

        :param user_id: The user_id of this Booking.
        :type: int
        """

        self._user_id = user_id

    @property
    def creation_date(self):
        """
        Gets the creation_date of this Booking.

        :return: The creation_date of this Booking.
        :rtype: str
        """
        return self._creation_date

    @creation_date.setter
    def creation_date(self, creation_date):
        """
        Sets the creation_date of this Booking.

        :param creation_date: The creation_date of this Booking.
        :type: str
        """

        self._creation_date = creation_date

    @property
    def booking_tickets(self):
        """
        Gets the booking_tickets of this Booking.
        List of booking ticket identifier

        :return: The booking_tickets of this Booking.
        :rtype: list[int]
        """
        return self._booking_tickets

    @booking_tickets.setter
    def booking_tickets(self, booking_tickets):
        """
        Sets the booking_tickets of this Booking.
        List of booking ticket identifier

        :param booking_tickets: The booking_tickets of this Booking.
        :type: list[int]
        """

        self._booking_tickets = booking_tickets

    @property
    def total_amount(self):
        """
        Gets the total_amount of this Booking.

        :return: The total_amount of this Booking.
        :rtype: list[TaxMoneyList]
        """
        return self._total_amount

    @total_amount.setter
    def total_amount(self, total_amount):
        """
        Sets the total_amount of this Booking.

        :param total_amount: The total_amount of this Booking.
        :type: list[TaxMoneyList]
        """

        self._total_amount = total_amount

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Booking):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
